package net.p0f.samples.rhpam_fuse_integration.rules;

import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.rule.QueryResults;
import org.kie.api.runtime.rule.QueryResultsRow;

import net.p0f.samples.rhpam_fuse_integration.shared_dom.Award;
import net.p0f.samples.rhpam_fuse_integration.shared_dom.Customer;

public class AssertAndQueryFacts {
	public static void main(String... args) {
		KieContainer c = KieServices.Factory.get().getKieClasspathContainer();
		
		// Instantiate the awards KB and its default session.
		KieSession s = c.getKieBase("awards").newKieSession();

		Customer c1 = new Customer();
		c1.setName("John Doe");
		c1.setAge(27);
		c1.setLoyaltyLevel(Customer.GOLD);
		c1.setLoyaltyAge(5);
		c1.setMilesFlown(15000);

		Customer c2 = new Customer();
		c2.setName("Jane Doe");
		c2.setAge(35);
		c2.setLoyaltyLevel(Customer.PLATINUM);
		c2.setLoyaltyAge(10);

		s.insert(c1);
		s.insert(c2);

		s.fireAllRules();

		System.out.println("******** Examining Working Memory ********");

		QueryResults qr = s.getQueryResults("Get Awards");
		for (QueryResultsRow qrr : qr) {
			Award award = (Award)qrr.get("award");
			System.out.println("Found award: " + award.toString());
		}

		s.dispose();
	}
}
