package net.p0f.samples.rhpam_fuse_integration.rules;

import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

import net.p0f.samples.rhpam_fuse_integration.shared_dom.Award;
import net.p0f.samples.rhpam_fuse_integration.shared_dom.Customer;

public class FactIntegritySingle {

	public static void main(String[] args) {
		KieContainer c = KieServices.Factory.get().getKieClasspathContainer();
		KieSession s = c.getKieBase("integrity").newKieSession();

		Customer c1 = new Customer();
		c1.setName("John Doe");
		c1.setAge(27);
		c1.setLoyaltyLevel(Customer.GOLD);
		c1.setLoyaltyAge(10);
		c1.setMilesFlown(15000);

		Award a1 = new Award("Hey, John!");
		a1.setCarrier(c1);

		s.insert(c1);
		s.insert(a1);

		// This correctly prints award/customer combo, as expected.
		s.fireAllRules();
		
		s.dispose();
	}

}
